%define anolis_release 1
%global toolchain clang
%undefine _include_frame_pointers
%global libcxx_version 16.0.4
%global libcxx_srcdir libcxx-%{libcxx_version}.src
%global libcxxabi_srcdir libcxxabi-%{libcxx_version}.src

Name:		libcxx
Version:	%{libcxx_version}
Release:	%{anolis_release}%{?dist}
Summary:	C++ standard library targeting C++11
License:	Apache-2.0 WITH LLVM-exception OR MIT OR NCSA
URL:		http://libcxx.llvm.org/
Source0:	https://github.com/llvm/llvm-project/releases/download/llvmorg-%{libcxx_version}%{?rc_ver:-rc%{rc_ver}}/%{libcxx_srcdir}.tar.xz
Source2:	https://github.com/llvm/llvm-project/releases/download/llvmorg-%{libcxx_version}%{?rc_ver:-rc%{rc_ver}}/%{libcxxabi_srcdir}.tar.xz
Source5:	CMakeLists.txt

BuildRequires:	clang
BuildRequires:	llvm-devel cmake ninja-build
# We need python3-devel for %%py3_shebang_fix
BuildRequires:  python3-devel

Requires: libcxxabi = %{version}-%{release}

%description
libc++ is a new implementation of the C++ standard library, targeting C++11.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%package devel
Summary:	Headers and libraries for libcxx devel
Requires:	%{name} = %{version}-%{release}
Requires:	libcxxabi-devel = %{version}

%description devel
%{summary}.

%package static
Summary:	Static libraries for libcxx

%description static
%{summary}.

%package -n libcxxabi
Summary:	Low level support for a standard C++ library

%description -n libcxxabi
libcxxabi provides low level support for a standard C++ library.

%package -n libcxxabi-doc
Summary:        Documentation files for %{name}
Requires:       libcxxabi = %{version}-%{release}
BuildArch:      noarch

%description -n libcxxabi-doc
The %{name}-doc package contains documentation files for %{name}.

%package -n libcxxabi-devel
Summary:	Headers and libraries for libcxxabi devel
Requires:	libcxxabi = %{version}-%{release}

%description -n libcxxabi-devel
%{summary}.

%package -n libcxxabi-static
Summary:	Static libraries for libcxxabi

%description -n libcxxabi-static
%{summary}.

%prep
%setup -T -q -b 0 -n %{libcxx_srcdir}
%setup -T -q -b 2 -n %{libcxxabi_srcdir}
%setup -T -c -n build
 
cp %{SOURCE5} .
mv ../%{libcxx_srcdir} libcxx
mv ../%{libcxxabi_srcdir} libcxxabi
%autopatch -p1
 
%py3_shebang_fix libcxx/utils/

%build

%cmake -GNinja \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DCMAKE_MODULE_PATH=%{_libdir}/cmake/llvm \
	-DLIBCXX_LIBDIR_SUFFIX:STRING=64 \
	-DLIBCXXABI_LIBDIR_SUFFIX:STRING=64 \
	-DLIBCXX_INCLUDE_BENCHMARKS=OFF \
	-DLIBCXX_STATICALLY_LINK_ABI_IN_STATIC_LIBRARY=ON \
	-DLIBCXX_ENABLE_ABI_LINKER_SCRIPT=ON

%cmake_build

%install

%cmake_install

%files
%license libcxx/LICENSE.TXT
%{_libdir}/libc++.so.*

%files doc
%doc libcxx/CREDITS.TXT libcxx/TODO.TXT

%files devel
%{_includedir}/c++/
%exclude %{_includedir}/c++/v1/cxxabi.h
%exclude %{_includedir}/c++/v1/__cxxabi_config.h
%{_libdir}/libc++.so

%files static
%license libcxx/LICENSE.TXT
%{_libdir}/libc++.a
%{_libdir}/libc++experimental.a

%files -n libcxxabi
%license libcxxabi/LICENSE.TXT
%{_libdir}/libc++abi.so.*

%files -n libcxxabi-doc
%doc libcxxabi/CREDITS.TXT

%files -n libcxxabi-devel
%{_includedir}/c++/v1/cxxabi.h
%{_includedir}/c++/v1/__cxxabi_config.h
%{_libdir}/libc++abi.so

%files -n libcxxabi-static
%{_libdir}/libc++abi.a

%changelog
* Thu May 18 2023 Funda Wang <fundawang@yeah.net> - 16.0.4-1
- New version 16.0.4

* Fri Apr 14 2023 Funda Wang <fundawang@yeah.net> - 16.0.1-1
- New version 16.0.1

* Wed Feb 1 2023 chen_yu_ao <m15927509890@163.com> - 15.0.7-1
- Init package from upstream
